#!/usr/local/bin/perl
# disable_domain.cgi
# Temporarily disable a domain, after asking first

require './virtual-server-lib.pl';
&ReadParse();
$d = &get_domain($in{'dom'});
$access{'edit'} && &can_edit_domain($d) || &error($text{'edit_ecannot'});
$d->{'disabled'} && &error($text{'disable_ealready'});

&header($text{'disable_title'}, "");
print "<hr>\n";

@disable = grep { $d->{$_} || $_ eq 'user' } split(/,/, $config{'disable'});
if (!@disable) {
	# Nothing to do!
	print "<p>$text{'disable_nothing'}<p>\n";
	}
elsif (!$in{'confirm'}) {
	# Ask the user if he is sure
	@distext = map { $text{"disable_".$_} } @disable;
	if (@distext == 1) {
		$distext = $distext[0];
		}
	elsif (@distext == 2) {
		$distext = &text('disable_and', $distext[0], $distext[1]);
		}
	else {
		$dislast = pop(@distext);
		$distext = &text('disable_and', join(", ", @distext), $dislast);
		}

	print &check_clicks_function();
	print "<p>",&text('disable_rusure2', "<tt>$d->{'dom'}</tt>",
			  $distext),"<p>\n";
	print $text{'disable_undo'},"<p>\n";
	print "<center><form action=disable_domain.cgi>\n";
	print "<input type=hidden name=dom value='$in{'dom'}'>\n";
	print "<input type=submit name=confirm ",
	      "value='$text{'disable_ok'}' onClick='check_clicks(form)'>\n";
	print "</form></center>\n";
	}
else {
	# Go ahead and do it ..
	%disable = map { $_, 1 } @disable;

	# Run the before command
	&set_domain_envs($d, "DISABLE_DOMAIN");
	$merr = &making_changes();
	&error(&text('disable_emaking', "<tt>$merr</tt>")) if (defined($merr));

	if ($disable{'user'}) {
		# Lock the Unix user's account
		&require_useradmin();
		local @allusers = &useradmin::list_users();
		local ($uinfo) = grep { $_->{'user'} eq $d->{'user'}} @allusers;
		if ($uinfo) {
			print $text{'disable_unix'},"<br>\n";
			&useradmin::set_user_envs($uinfo, 'MODIFY_USER', "");
			&useradmin::making_changes();
			$d->{'disabled_oldpass'} = $uinfo->{'pass'};
			$uinfo->{'pass'} = $uconfig{'lock_string'};
			&useradmin::modify_user($uinfo, $uinfo);
			&useradmin::made_changes();
			print $text{'setup_done'},"<p>\n";
			push(@disabled, "user");
			}
		}

	if ($d->{'web'} && $disable{'web'}) {
		# Re-direct website to disabled page
		&disable_apache($d);
		&restart_apache();
		push(@disabled, "web");
		}

	if ($d->{'dns'} && $disable{'dns'}) {
		# Delete zone from named.conf, but leave file
		&disable_bind($d);
		&restart_bind();
		push(@disabled, "dns");
		}

	if ($d->{'mail'} && $disable{'mail'}) {
		# Take mail domain out of accepted list
		&disable_mail($d);
		push(@disabled, "mail");
		}

	if ($d->{'mysql'} && $disable{'mysql'}) {
		# Disable mysql user
		&disable_mysql($d);
		push(@disabled, "mysql");
		}

	if ($d->{'postgres'} && $disable{'postgres'}) {
		# Disable postgresql user
		&disable_postgres($d);
		push(@disabled, "postgres");
		}

	# Save new domain details
	print $text{'save_domain'},"<br>\n";
	$d->{'disabled'} = join(",", @disabled);
	&save_domain($d);
	print $text{'setup_done'},"<p>\n";

	# Run the after command
	&set_domain_envs($d, "DISABLE_DOMAIN");
	&made_changes();
	}

print "<hr>\n";
&footer("edit_domain.cgi?dom=$in{'dom'}", $text{'edit_return'},
	"", $text{'index_return'});

